#target indesign
var doc = app.activeDocument;
var allPStylesNames = new Array();
var allPStyles = new Array();
for(var i = 0; i <doc.allParagraphStyles.length; i++ ){
	allPStyles[i] = doc.allParagraphStyles[i];
	allPStylesNames[i] = getFullParagraphStName(allPStyles[i]);
};

var allOStylesNames = new Array();
var allOStyles = new Array();
for(var i = 0; i <doc.allObjectStyles.length; i++ ){
	allOStyles[i] = doc.allObjectStyles[i];
	allOStylesNames[i] = getFullObjectStName(allOStyles[i]);
};

// DIALOG
// ======
var dialog = new Window("dialog"); 
    dialog.text = "Index Graphics"; 
    dialog.orientation = "column"; 
    dialog.alignChildren = ["center","top"]; 
    dialog.spacing = 9; 
    dialog.margins = [10,5,10,10]; 

var group1 = dialog.add("group", undefined, {name: "group1"}); 
    group1.orientation = "column"; 
    group1.alignChildren = ["left","center"]; 
    group1.spacing = 5; 
    group1.margins = 5; 

var group2 = group1.add("group", undefined, {name: "group2"}); 
    group2.orientation = "row"; 
    group2.alignChildren = ["center","center"]; 
    group2.spacing = 10; 
    group2.margins = 0; 
    group2.alignment = ["center","center"]; 

var panel1 = group2.add("panel", undefined, undefined, {name: "panel1"}); 
    panel1.text = "Pages"; 
    panel1.orientation = "column"; 
    panel1.alignChildren = ["fill","top"]; 
    panel1.spacing = 10; 
    panel1.margins = 8; 
    panel1.alignment = ["center","fill"]; 

var group3 = panel1.add("group", undefined, {name: "group3"}); 
    group3.orientation = "row"; 
    group3.alignChildren = ["left","center"]; 
    group3.spacing = 10; 
    group3.margins = 0; 

var statictext1 = group3.add("statictext", undefined, undefined, {name: "statictext1"}); 
    statictext1.text = "Index Pages "; 
    statictext1.preferredSize.width = 88; 

var edittext1 = group3.add('edittext {properties: {name: "edittext1"}}'); 
	edittext1.text = doc.extractLabel("pagesIndex")
    edittext1.preferredSize.width = 90; 

var group4 = panel1.add("group", undefined, {name: "group4"}); 
    group4.orientation = "row"; 
    group4.alignChildren = ["left","center"]; 
    group4.spacing = 10; 
    group4.margins = 0; 

var statictext2 = group4.add("statictext", undefined, undefined, {name: "statictext2"}); 
    statictext2.text = "Exclude Pages"; 
    statictext2.preferredSize.width = 88; 

var edittext2 = group4.add('edittext {properties: {name: "edittext2"}}'); 
	edittext2.text = doc.extractLabel("pagesExclude")
    edittext2.preferredSize.width = 90; 
    edittext2.alignment = ["left","center"]; 

var panel2 = group2.add("panel", undefined, undefined, {name: "panel2"}); 
    panel2.text = "Size"; 
    panel2.orientation = "column"; 
    panel2.alignChildren = ["fill","top"]; 
    panel2.spacing = 10; 
    panel2.margins = 8; 
    panel2.alignment = ["center","fill"]; 

var group5 = panel2.add("group", undefined, {name: "group5"}); 
    group5.orientation = "row"; 
    group5.alignChildren = ["left","center"]; 
    group5.spacing = 10; 
    group5.margins = 0; 

var statictext3 = group5.add("statictext", undefined, undefined, {name: "statictext3"}); 
    statictext3.text = "Offset Frame"; 
    statictext3.preferredSize.width = 80; 

var edittext3 = group5.add('edittext {properties: {name: "edittext3"}}'); 
	if (doc.extractLabel("myLabelOffset") == "") {
		edittext3.text = "0"
	} else {edittext3.text = doc.extractLabel("myLabelOffset")}
    edittext3.preferredSize.width = 78; 
    edittext3.alignment = ["left","fill"]; 

var statictext4 = group5.add("statictext", undefined, undefined, {name: "statictext4"}); 
    statictext4.text = "mm"; 
    statictext4.preferredSize.width = 30; 

var group6 = panel2.add("group", undefined, {name: "group6"}); 
    group6.orientation = "row"; 
    group6.alignChildren = ["left","center"]; 
    group6.spacing = 10; 
    group6.margins = 0; 

var statictext5 = group6.add("statictext", undefined, undefined, {name: "statictext5"}); 
    statictext5.text = "Width Frame"; 
    statictext5.preferredSize.width = 80; 

var edittext4 = group6.add('edittext {properties: {name: "edittext4"}}'); 
	if (doc.extractLabel("myLabelWidth") == "") {
		edittext4.text = "By Width"
	} else {edittext4.text = doc.extractLabel("myLabelWidth")}
    edittext4.preferredSize.width = 80; 
    edittext4.alignment = ["left","fill"]; 

var statictext6 = group6.add("statictext", undefined, undefined, {name: "statictext6"}); 
    statictext6.text = "mm"; 
    statictext6.preferredSize.width = 30; 

var panel3 = group1.add("panel", undefined, undefined, {name: "panel3"}); 
    panel3.text = "Text format"; 
    panel3.orientation = "row"; 
    panel3.alignChildren = ["center","center"]; 
    panel3.spacing = 10; 
    panel3.margins = 8; 
    panel3.alignment = ["fill","center"]; 

var statictext7 = panel3.add("statictext", undefined, undefined, {name: "statictext7"}); 
    statictext7.text = "Prefix"; 
    statictext7.preferredSize.width = 36; 
    statictext7.alignment = ["center","center"]; 

var edittext5 = panel3.add('edittext {properties: {name: "edittext5"}}'); 
	edittext5.text = doc.extractLabel("prefix")
    edittext5.preferredSize.width = 55; 
    edittext5.alignment = ["center","center"]; 

var divider1 = panel3.add("panel", undefined, undefined, {name: "divider1"}); 
    divider1.alignment = "fill"; 

var statictext8 = panel3.add("statictext", undefined, undefined, {name: "statictext8"}); 
    statictext8.text = "Separator"; 
    statictext8.preferredSize.width = 61; 
    statictext8.alignment = ["center","center"]; 

var edittext6 = panel3.add('edittext {justify: "center", properties: {name: "edittext6"}}'); 
	if (doc.extractLabel("separator") == "") {
		edittext6.text = ","
	} else {edittext6.text = doc.extractLabel("separator")}
    edittext6.preferredSize.width = 23; 
    edittext6.alignment = ["center","center"]; 

var divider2 = panel3.add("panel", undefined, undefined, {name: "divider2"}); 
    divider2.alignment = "fill"; 

var statictext9 = panel3.add("statictext", undefined, undefined, {name: "statictext9"}); 
    statictext9.text = "Style"; 
    statictext9.preferredSize.width = 31; 
    statictext9.alignment = ["center","center"]; 

var dropdown1 = panel3.add("dropdownlist", undefined, undefined, {name: "dropdown1", items: allPStylesNames}); 
    dropdown1.selection = 0; 
	if (doc.extractLabel("styleIndex") == "") {
		dropdown1.selection = 0
	} else {dropdown1.selection = doc.extractLabel("styleIndex")}
    dropdown1.preferredSize.width = 132; 
	
// PANEL4
// ======
var panel4 = group1.add("panel", undefined, undefined, {name: "panel4"}); 
    panel4.text = "Index Numbering"; 
    panel4.orientation = "row"; 
    panel4.alignChildren = ["left","top"]; 
    panel4.spacing = 10; 
    panel4.margins = 10; 
    panel4.alignment = ["fill","center"]; 

var statictext10 = panel4.add("statictext", undefined, undefined, {name: "statictext10"}); 
    statictext10.text = "Format"; 
    statictext10.alignment = ["left","center"]; 

var dropdown2_array = ["Not Numbering","1,2,3","01,02,03","001,002,003","0001,0002,0003","00001,00002,00003"]; 
var dropdown2 = panel4.add("dropdownlist", undefined, undefined, {name: "dropdown2", items: dropdown2_array}); 
	if (doc.extractLabel("formatIndexNum") == "") {
		dropdown2.selection = 0
	} else {dropdown2.selection = doc.extractLabel("formatIndexNum")}
    dropdown2.preferredSize.width = 120; 

var divider4 = panel4.add("panel", undefined, undefined, {name: "divider4"}); 
    divider4.alignment = "fill"; 

var statictext11 = panel4.add("statictext", undefined, undefined, {name: "statictext11"}); 
    statictext11.text = "Object Style"; 
    statictext11.alignment = ["left","center"]; 

var dropdown3_array = ["Item 1","-","Item 2"]; 
var dropdown3 = panel4.add("dropdownlist", undefined, undefined, {name: "dropdown3", items: allOStylesNames}); 
    if (doc.extractLabel("styleIndexNum") == "") {
		dropdown3.selection = 0
	} else {dropdown3.selection = doc.extractLabel("styleIndexNum")}
    dropdown3.preferredSize.width = 180; 
    dropdown3.alignment = ["left","center"]; 
//=====================================================
var group7 = dialog.add("group", undefined, {name: "group7"}); 
    group7.orientation = "row"; 
    group7.alignChildren = ["left","center"]; 
    group7.spacing = 10; 
    group7.margins = 0; 

var button1 = group7.add("button", undefined, "OK"); 
	var ok = false;
	button1.onClick = function () {ok = true; dialog.destroy();}

var button2 = group7.add("button", undefined, "Cancel"); 

var group8 = dialog.add("group", undefined, {name: "group8"}); 
	
dialog.show();



if (ok) {
	app.doScript(indexGraphics, ScriptLanguage.JAVASCRIPT, [], UndoModes.ENTIRE_SCRIPT, 'Index Graphics');
	//indexGraphics();
};

function indexGraphics () {
	var pagesIndex = edittext1.text;
	var pagesExclude = edittext2.text;
	var separator = edittext6.text;
	var myLabelOffset = edittext3.text.replace(",", ".");
	var prefix = edittext5.text;
	var myLabelWidth = edittext4.text.replace(",", ".");
	var styleIndex = dropdown1.selection.index;
	var formatIndexNum = dropdown2.selection.index;
	var styleIndexNum = dropdown3.selection.index;
	
	doc.insertLabel ("pagesIndex", pagesIndex)
	doc.insertLabel ("pagesExclude", pagesExclude)
	doc.insertLabel ("separator", separator)
	doc.insertLabel ("myLabelOffset", myLabelOffset)
	doc.insertLabel ("prefix", prefix)
	doc.insertLabel ("myLabelWidth", myLabelWidth)
	doc.insertLabel ("styleIndex", String(styleIndex))
	doc.insertLabel ("formatIndexNum", String(formatIndexNum))
	doc.insertLabel ("styleIndexNum", String(styleIndexNum))
		
	var docPagesArr = [];
	for (i = 1; i <= doc.pages.length; i++) {
		docPagesArr.push(i);
	};

	var myOldXUnits = doc.viewPreferences.horizontalMeasurementUnits;
	var myOldYUnits = doc.viewPreferences.verticalMeasurementUnits;
	doc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	doc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;

	var pagesProc = excludePages(docPagesArr, parsePageString(pagesExclude));
	var pagesProc = excludePages(pagesProc, parsePageString(pagesIndex));
	app.scriptArgs.clear();
	for (var i = 0; i < pagesProc.length; i++) {
		p = pagesProc[i];
		var pg = doc.pages[p-1].allGraphics;
		var nameArr = [];
		for (var n = 0; n < pg.length; n++) {
			nameArr.push(String(pg[n].itemLink.filePath));
		};
		nameArr = arrayCompress(nameArr);
		for (var n = 0; n < nameArr.length; n++) {
			name = String(nameArr[n]);
			if (app.scriptArgs.get(name) != "") {
				value = app.scriptArgs.get(name) + separator + String(p);
				app.scriptArgs.set(name, value);
			} else {
			value = String(p);
			app.scriptArgs.set(name, value);
			};
		};
	};

	var myLabelLayer = doc.layers.item("indexGraphics"); 
	try{ myLabelLayer.remove()} catch (e){};
	myLabelLayer = doc.layers.add({name:"indexGraphics"}); 
	var pi = parsePageString(pagesIndex);
	var indexNum = 1;
	for (var i = 0; i < pi.length; i++) {
		p = pi[i];
		var pg = doc.pages[p-1].allGraphics;
		if (formatIndexNum != 0) {
			pg = sortByPositionTopLeft(pg);
		};
		for (var n = 0; n < pg.length; n++) {
			var myLabel = app.scriptArgs.get(String(pg[n].itemLink.filePath));
			if (myLabel != "") {
				var myFrame = pg[n].parent;
				myX1 = myFrame.geometricBounds[1];
				if (isNaN(myLabelOffset)||Number(myLabelOffset) == 0) {
					myY1 = myFrame.geometricBounds[2];
				} else { myY1 = myFrame.geometricBounds[2] + Number(myLabelOffset)};
				if (isNaN(myLabelWidth)||Number(myLabelWidth) == 0) {
					myX2 = myFrame.geometricBounds[3];
				} else { myX2 = myX1+Number(myLabelWidth)}; 
				myY2 = myY1+10;
				var myTextFrame = myFrame.parent.textFrames.add(myLabelLayer, undefined, undefined,{contents:prefix+myLabel});
				myTextFrame.textFramePreferences.autoSizingReferencePoint = AutoSizingReferenceEnum.TOP_LEFT_POINT;
				myTextFrame.parentStory.texts.item(0).appliedParagraphStyle = allPStyles[styleIndex];
				myTextFrame.geometricBounds = [myY1, myX1, myY2, myX2];
				myTextFrame.textFramePreferences.autoSizingType = AutoSizingTypeEnum.HEIGHT_ONLY;
				myTextFrame.textFramePreferences.autoSizingType = AutoSizingTypeEnum.OFF;
				};
				if (formatIndexNum != 0) {
					var myNumFrame = myFrame.parent.textFrames.add(myLabelLayer, undefined, undefined,{contents:String(zeroPad(indexNum++, formatIndexNum))});
					myNumFrame.geometricBounds = myFrame.geometricBounds;
					myNumFrame.appliedObjectStyle = allOStyles[styleIndexNum];
					myNumFrame.textFramePreferences.autoSizingReferencePoint = AutoSizingReferenceEnum.TOP_LEFT_POINT;
					myNumFrame.textFramePreferences.autoSizingType = AutoSizingTypeEnum.HEIGHT_AND_WIDTH;
					myNumFrame.appliedObjectStyle = allOStyles[styleIndexNum];
				};		
		};
	};
	doc.viewPreferences.horizontalMeasurementUnits = myOldXUnits;
	doc.viewPreferences.verticalMeasurementUnits = myOldYUnits;
};

function zeroPad(num,count) {
	var numZeropad = num + '';
	while(numZeropad.length < count) {
		numZeropad = "0" + numZeropad;
	};
	return numZeropad;
};

function sortByPositionTopLeft(pgArr) {
	pgArr.sort(function (a, b) {return (a.parent.geometricBounds[0] - b.parent.geometricBounds[0])});	
	var count = 0; f = 0;
	var ref = pgArr[0];
	var lineArr = []; sortPg = [];
	for (var r = 0; r < pgArr.length; r++) {
		if (ref.parent.geometricBounds[2] > pgArr[r].parent.geometricBounds[0]) {
			lineArr[f] = pgArr[r];
			f++;
		} else {
			lineArr.sort(function (a, b) {return (a.parent.geometricBounds[1] - b.parent.geometricBounds[1])});	
			for (var i = 0; i < lineArr.length; i++) {
				sortPg[count] = lineArr[i];
				count++;
			};
			f = 0;
			lineArr = [];
			ref = pgArr[r];
			lineArr[f] = pgArr[r];
			f++;
		};
	};
	lineArr.sort(function (a, b) {return (a.parent.geometricBounds[1] - b.parent.geometricBounds[1])});	
	for (var i = 0; i < lineArr.length; i++) {
		sortPg[count] = lineArr[i];
		count++;
	};
	return sortPg;
};

function parsePageString(pageString) {
  var pages = [];
  var ranges = pageString.split(',');
  for (i = 0; i < ranges.length; i++ ) {
    if (includes(ranges[i], '-')) {
      start = ranges[i].split('-')[0];
	  end = ranges[i].split('-')[1];
      for (i = Number(start); i <= Number(end); i++) {
        pages.push(i);
      };
    } else {
      pages.push(Number(ranges[i]));
    };
  };
  return pages;
};

function excludePages(pageArr, excludeArr) {
	var resultArray = [];
	for (var i = 0; i < pageArr.length; i++) {
		var isExcluded = false;
		for (var j = 0; j < excludeArr.length; j++) {
			if (pageArr[i] === excludeArr[j]) {
				isExcluded = true;
				break;
			};
		};
		if (!isExcluded) {
			resultArray.push(pageArr[i]);
		};
	};
	return resultArray;
};

function includes(arr, symbol){
    var i = arr.length;
    while (i--) {
        if (arr[i] === symbol) { return true; }
    };
    return false;
};

function arrayCompress(array){
 var str = array.sort().join('\r')+'\r';
 str = str.replace(/([^\r]+\r)(\1)+/g,'$1');
 str = str.replace(/\r$/,'');
 return str.split('\r');
};

function getFullParagraphStName(pStyle) {
	pStyleName = pStyle.name;
	parentStyle = pStyle.parent;
	while (parentStyle == "[object ParagraphStyleGroup]") {
		pStyleName = parentStyle.name + ":" + pStyleName;
		parentStyle =  parentStyle.parent;
	};
	return  pStyleName;
};

function getFullObjectStName(oStyle) {
	oStyleName = oStyle.name;
	parentStyle = oStyle.parent;
	while (parentStyle == "[object ObjectStyleGroup]") {
		oStyleName = parentStyle.name + ":" + oStyleName;
		parentStyle =  parentStyle.parent;
	};
	return  oStyleName;
};


